%global momorel 1

%bcond_without lightning

%define version_internal 1.0b3
%define progdir %{_libdir}/%{name}-%{version_internal}pre
%define thunderbird_version 3.1.14
%define libnotify_version 0.4
%define lightning_extname %{_libdir}/mozilla/extensions/{3550f703-e582-4d05-9a08-453d09bdfdc6}/{e2fda1a4-762b-4020-b5ad-a41df1933103}
%define gdata_extname %{_libdir}/mozilla/extensions/{3550f703-e582-4d05-9a08-453d09bdfdc6}/{a62ef8ec-5fdc-40c2-873c-223b8a6925cc}

# This is to filter unwanted provides, that should be provided only by gecko-devel
%define _use_internal_dependency_generator 0
%define __find_requires %{SOURCE100} %{buildroot}

Name:           sunbird
Version:        1.0
Release:        0.0.20110621.%{momorel}m%{?dist}
Summary:        Calendar application built upon Mozilla toolkit

Group:          Applications/Productivity
License:        MPLv1.1 or GPLv2+ or LGPLv2+
URL:            http://www.mozilla.org/projects/calendar/sunbird/
Source0:        http://releases.mozilla.org/pub/mozilla.org/thunderbird/releases/%{thunderbird_version}/source/thunderbird-%{thunderbird_version}.source.tar.bz2
NoSource:       0
Source1:        sunbird.desktop
Source2:        sunbird-l10n.tar
#sunbird-langpacks-0.9.tar.gz
# This is used just for langpacks.
# TODO: build them!
#Source4:        http://releases.mozilla.org/pub/mozilla.org/calendar/lightning/releases/0.9/lightning-0.9.linux-i686.xpi
Source100:      find-external-requires

# Pulled from Thunderbird
Patch0:         mozilla-jemalloc.patch
# Fixes gcc complain that nsFrame::delete is protected
Patch1:         xulrunner-1.9.2.1-build.patch
Patch2:         cstddef.patch
# Ours
Patch10:        sunbird-1.0-libical.patch
Patch11:        sunbird-1.0-uilocale.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libIDL-devel
BuildRequires:  desktop-file-utils
BuildRequires:  libgnomeui-devel
BuildRequires:  krb5-devel
BuildRequires:  pango-devel
BuildRequires:  freetype-devel >= 2.1.9
BuildRequires:  libXt-devel
BuildRequires:  desktop-file-utils
BuildRequires:  nss-devel
BuildRequires:  nspr-devel
BuildRequires:  libical-devel
BuildRequires:  zip
BuildRequires:  autoconf213
BuildRequires:  alsa-lib-devel
BuildRequires:  libnotify-devel >= %{libnotify_version}
BuildRequires:  libjpeg-devel >= 8a

Requires(post):  desktop-file-utils
Requires(postun): desktop-file-utils

AutoProv: 0

%description
Mozilla Sunbird is a cross-platform calendar application, built upon
Mozilla Toolkit. It brings Mozilla-style ease-of-use to your
calendar, without tying you to a particular storage solution.


%if %with lightning
%package -n thunderbird-lightning
Summary:        The calendar extension to Thunderbird
Group:          Applications/Productivity
Requires:       thunderbird >= %{thunderbird_version}
Obsoletes:      thunderbird-lightning-wcap <= 0.8
Provides:       thunderbird-lightning-wcap = %{version}-%{release}
AutoProv: 0

%description -n thunderbird-lightning
Lightning brings the Sunbird calendar to the popular email client,
Mozilla Thunderbird. Since it's an extension, Lightning is tightly
integrated with Thunderbird, allowing it to easily perform email-related
calendaring tasks.

%endif

%prep
%setup -n comm-1.9.2 -q -a 2

%patch0 -p0 -b .jemalloc
%patch1 -p1 -b .protected
%patch2 -p1 -b .cstddef
%patch10 -p0 -b .libical
%patch11 -p0 -b .uilocale

find . -name '*.cpp' -o -name '*.h' |xargs chmod -x

%build
cat >.mozconfig <<EOF
ac_add_options --disable-crashreporter
ac_add_options --disable-debug
ac_add_options --disable-installer
ac_add_options --disable-install-strip
ac_add_options --disable-strip
ac_add_options --disable-tests
ac_add_options --disable-updater
ac_add_options --disable-xprint
ac_add_options --enable-application=calendar
ac_add_options --enable-calendar
ac_add_options --enable-canvas
ac_add_options --enable-default-toolkit=cairo-gtk2
ac_add_options --enable-optimize="$(echo "$RPM_OPT_FLAGS -fpermissive" |sed -e 's/-O2/-Os/;s/-Wall//')"
ac_add_options --enable-pango
ac_add_options --enable-svg
ac_add_options --enable-system-cairo
ac_add_options --enable-xinerama
ac_add_options --libdir="%{_libdir}"
ac_add_options --prefix="%{_prefix}"
ac_add_options --with-pthreads
ac_add_options --with-system-jpeg
ac_add_options --with-system-nspr
ac_add_options --with-system-nss
ac_add_options --with-system-zlib
ac_add_options --disable-necko-wifi
EOF

make -f client.mk build

%install
rm -rf $RPM_BUILD_ROOT

# make install is bogus
# copy tree, break symlinks
mkdir -p $RPM_BUILD_ROOT%{progdir}
cp -rL mozilla/dist/bin/* $RPM_BUILD_ROOT%{progdir}
mkdir $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{progdir}/%{name} $RPM_BUILD_ROOT%{_bindir}/%{name}

desktop-file-install --vendor=                          \
        --dir=$RPM_BUILD_ROOT%{_datadir}/applications/  \
        %{SOURCE1}

# Icon
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/128x128/apps
cp $RPM_BUILD_ROOT%{progdir}/chrome/icons/default/default128.png \
        $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/128x128/apps/%{name}.png

# Install langpacks
mkdir -p $RPM_BUILD_ROOT%{progdir}/extensions
ls sunbird-l10n/*.xpi |while read PACK
do
        LANGUAGE=$(echo $PACK |sed 's,sunbird-l10n/sunbird-%{version_internal}pre.\(.*\).langpack.xpi,\1,')
        DIR=$RPM_BUILD_ROOT%{progdir}/extensions/langpack-$LANGUAGE@sunbird.mozilla.org
        mkdir -p $DIR
        unzip -qod $DIR $PACK
        find $DIR -type f |xargs chmod 0644

        # Fix #441500
        sed 's/\r//g' $DIR/install.rdf |awk '/^$/ {next} {print}' >lala
        touch -r $DIR/install.rdf lala
        mv lala $DIR/install.rdf

done

# GData provider for sunbird
mkdir -p $RPM_BUILD_ROOT%{progdir}/extensions/%{gdata_extname}
touch $RPM_BUILD_ROOT%{progdir}/extensions/%{gdata_extname}/chrome.manifest
unzip -qod $RPM_BUILD_ROOT%{progdir}/extensions/%{gdata_extname} \
        mozilla/dist/xpi-stage/gdata-provider.xpi

%if %with lightning
# Avoid "Chrome Registration Failed" message on first startup and extension installation
mkdir -p $RPM_BUILD_ROOT%{lightning_extname}
touch $RPM_BUILD_ROOT%{lightning_extname}/chrome.manifest
mkdir -p $RPM_BUILD_ROOT%{gdata_extname}
touch $RPM_BUILD_ROOT%{gdata_extname}/chrome.manifest

# Lightning and GData provider for it
unzip -qod $RPM_BUILD_ROOT%{lightning_extname} mozilla/dist/xpi-stage/lightning.xpi
unzip -qod $RPM_BUILD_ROOT%{gdata_extname} mozilla/dist/xpi-stage/gdata-provider.xpi

# No langpacks for preview release
%if 0
# Unpack lightning language packs, except en_US
unzip -l %{SOURCE4} '*.jar' |
        awk '/-[^\/]*\.jar/ && !/en-US/ {print $4}' |
        xargs unzip -qod $RPM_BUILD_ROOT%{mozilla_extensions_dir}/thunderbird-lightning %{SOURCE4}

# Register them
ls $RPM_BUILD_ROOT%{mozilla_extensions_dir}/thunderbird-lightning/chrome |
        sed -n '/en-US/n;s/\(\([^-]*\)-\(.*\)\.jar\)/locale \2 \3 jar:chrome\/\1!\/locale\/\3\/\2\//p' \
        >>$RPM_BUILD_ROOT%{mozilla_extensions_dir}/thunderbird-lightning/chrome.manifest
        # ^^^ I'm going to burn in hell for this ^^^
%endif
%endif

# Permissions fixup
find $RPM_BUILD_ROOT -name '*.xpm' -o -name '*.js' |
        xargs chmod 0644 mozilla/LICENSE
find $RPM_BUILD_ROOT -name '*.so' |xargs chmod 0755

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-desktop-database %{_datadir}/applications &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
        %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
update-desktop-database %{_datadir}/applications &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
        %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%files
%defattr(-,root,root,-)
%doc mozilla/LEGAL mozilla/LICENSE mozilla/README.txt
%{progdir}
%{_bindir}/sunbird
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/128x128/apps/sunbird.png

%if %with lightning
%files -n thunderbird-lightning
%doc mozilla/LEGAL mozilla/LICENSE mozilla/README.txt
%defattr(-,root,root,-)
%{lightning_extname}
%{gdata_extname}
%endif

%changelog
* Wed Sep  7 2011 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0-0.0.20110621-3m)
- rebuild against thunderbird-3.1.14

* Thu Aug 25 2011 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0-0.0.20110621-2m)
- rebuild against thunderbird-3.1.12

* Wed Jun 22 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20110621-1m)
- rebuild against thunderbird-3.1.11

* Mon May  2 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20110428.1m)
- rebuild against thunderbird-3.1.10

* Sun Apr 24 2011 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0-0.0.20110307.4m)
- rebuild against libnotify-0.7.2

* Wed Apr 13 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0-0.0.20110307.3m)
- modify FLAGS to enable build by gcc46
- import cstddef.patch from seamonkey

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0-0.0.20110307.2m)
- rebuild for new GCC 4.6

* Mon Mar  7 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20110307.1m)
- rebuild against thunderbird-3.1.9

* Wed Mar  2 2011 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20110302.1m)
- rebuild against thunderbird-3.1.8

* Fri Dec 10 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20101209.1m)
- rebuild against thunderbird-3.1.7

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0-0.0.20101027.2m)
- rebuild for new GCC 4.5

* Thu Oct 28 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20101027.1m)
- rebuild against thunderbird-3.1.6

* Wed Oct 20 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0-0.0.20101019.1m)
- rebuild against thunderbird-3.1.5

* Wed Sep  8 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100907.1m)
- rebuild against thunderbird-3.1.3
- the version_internal is 1.0b3

* Thu Sep  2 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0-0.0.20100803.3m)
- [BUG FIX] fix %%post and %%postun

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0-0.0.20100803.2m)
- full rebuild for mo7 release

* Fri Aug 20 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100803.1m)
- rebuild against thunderbird-3.1.2
- change lightning install location

* Thu Jul 22 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100720.1m)
- rebuild against thunderbird-3.1.1

* Sat Jun 26 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100624.1m)
- rebuild against thunderbird-3.1

* Wed Jun 23 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100617.1m)
- rebuild against thunderbird-3.0.5

* Sat Apr 10 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100317.2m)
- rebuild against libjpeg-8a

* Wed Mar 31 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100317.1m)
- rebuild against thunderbird-3.0.4

* Tue Mar  2 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100225.3m)
- rebuild against thunderbird-3.0.3

* Mon Mar  1 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20100225.2m)
- change progdir

* Mon Mar  1 2010 Masanobu Sato <satoshiga@momonga-linux.org>
- (1.0-0.0.20100225.1m)
- rebuild against thunderbird-3.0.2

* Sat Jan 23 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20090916.6m)
- rebuild against thunderbird-3.0.1

* Fri Dec 11 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0-0.0.20090916.5m)
- merge from T4R
-- 
-- * Thu Dec 10 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (1.0-0.0.20090916.4m)
-- - rebuild against thunderbird-3.0
-- 
-- * Wed Dec  2 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (1.0-0.0.20090916.3m)
-- - rebuild against thunderbird-3.0rc2
-- 
-- * Thu Nov 26 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (1.0-0.0.20090916.2m)
-- - rebuild against thunderbird-3.0rc1
-- 
-- * Wed Oct  7 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (1.0-0.0.20090916.1m)
-- - update hg snapshot
-- 
-- * Thu Jun 18 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
-- - (1.0-0.0.20090302.1m)
-- - sync with Fedora 11 (1.0-0.3.20090302hg), but lightning is not
--   compatibile with thunderbird-3.0b3pre
-- -- 
-- -- * Thu May 12 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.0-0.3.20090302hg
-- -- - Fix migration window size (0x0 is considered too small by some) (#499346)
-- -- 
-- -- * Wed Apr 29 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.0-0.2.20090302hg
-- -- - Fix the permissions for real now
-- -- 
-- -- * Tue Apr 28 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.0-0.1.20090302hg
-- -- - Update to version matching current Thunderbird

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9-4m)
- rebuild against gcc-4.4 and glibc-2.11

* Mon Sep 14 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9-3m)
- rebuild against libjpeg-7

* Sun Jul 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9-2m)
- disable official branding
- svn add generate-calendar-langpacks.sh
- fix desktop file

* Fri Apr 10 2009 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.9-1m)
- import from FC

* Sun Mar 1 2009 Lubomir Rintel <lkundrak@v3.sk> 0.9-6
- Fix build with GCC 4.4

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 24 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-4
- Disable lightning on EL-5 ppc, since there's no Desktop with thunderbird
- Fix summary

* Thu Oct 2 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-3
- Attempt to fix the libical patch's timezone problem

* Wed Sep 24 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-2
- Fix problem with symbol visibility and newer gcc I introduced with libical patch

* Tue Sep 23 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-1
- 0.9 GOLD
- Fix use of system nss and nspr4
- Link against system libical (#459923)
- Add language packs for lightning (#449770)

* Sun Aug 24 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-0.3.20080824cvs
- Newer snapshot closer to RC
- New langpacks
- Fix install root path

* Mon Aug 11 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-0.2.20080807cvs
- Get rid of relative symlinks
- Remove lignthing's libcalbasecomps.so provide
- Fix dependencies of scriptlets

* Sun Aug 10 2008 Lubomir Rintel <lkundrak@v3.sk> 0.9-0.1.20080807cvs
- First attempt at 0.9, CVS snapshot close to first RC
- Rewrite the requires generation, for it suffered bitrot

* Mon May 19 2008 Lubomir Rintel <lkundrak@v3.sk> 0.8-4
- Rebuild for new hunspell

* Tue Apr 08 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-3
- Really fix lightning dependencies (#441340)
- Fix "da" and "it" lanugage packs (#441500)

* Mon Apr 07 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-2
- Blacklist dependencies of lightning on files included in tb (#441340)
- Fix the extension update scriptlet escaping

* Fri Apr 04 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-1
- 0.8 GA

* Fri Apr 04 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-0.3.cvs20080331
- Translations

* Tue Apr 01 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-0.2.cvs20080331
- Unbreak dependencies (hopefully)
- Try concurrent builds again, they seem to work now

* Tue Apr 01 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.8-0.1.cvs20080331
- Corrected license tag to mention all the applicable Licenses
- Use libxul from XULrunner
- Post 0.8 Release Candidate 1
- Obsolete wcap subpackage -- got merged into mainline lightning

* Sun Mar 09 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.7-10
- Parralel makes were failing unpredictably

* Thu Feb 28 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.7-9
- Try to use the correct locale (#436693)

* Mon Jan 21 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.7-8
- Streamlined BuildRequires a bit
- Do not provide stuff that has to be provided by firefox
- Do not require what's in our fileset
- Removed redundant and useless Source0 without upstream

* Thu Jan 03 2008 Lubomir Kundrak <lkundrak@redhat.com> 0.7-7
- Add patch to correct build with FORTIFY_SOURCE
- Replace the name in .desktop file with a more descriptive one
- Add translations to .desktop file

* Sun Dec 30 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-6
- disable updater

* Tue Dec 11 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-5
- fix debuginfo package

* Tue Oct 30 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-4
- rename the mozilla-lightning subpackage to thunderbird-lightning
  since it's a thunderbird extension
- create a "chrome.manifest" file to avoid "Chrome Registration Failed" message

* Mon Oct 29 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-3
- be even more complicated: build the wcap-enabler extension
  (really, it's just cut'n'paste)

* Mon Oct 29 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-2
- split the lightning package
- use scriptlets and triggers based on the mugshot package

* Sat Oct 27 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.7-1
- version 0.7

* Tue Sep 11 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.5-3
- minor spec cleanups
- build the Lightning extension
- add an option to build with official branding

* Sun Sep 09 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.5-2
- fix icon

* Wed Jul 25 2007 Aurelien Bompard <abompard@fedoraproject.org> 0.5-1
- initial release
